/*
 * $Id: uplmain.c,v 1.3 1998/05/12 02:55:45 jbourne Exp $
 *
 * Based on code written by an anonymous software socialist.
 * 
 * modified for use in CGI's by James Bourne <jbourne@hardrock.org>
 * May 9, 1998.  See the file COPYING for more information on Copyright
 *   
 *   Copyright (C) 1998  James Bourne <jbourne@hardrock.org>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <cgiupl.h>

/*
 * PLEASE READ THESE NOTES
 *
 * contentLength, cgiUploadDir and bytesRead are both globals in the
 * cgiupl.h file.  cgiUploadDir must be set.  If cgiUploadDir[0] == '\0'
 * then it will be set by the lib to /tmp/ but this is not the best way as
 * who knows what will be in that var if it's not initialized.
 *
 * Set contentLength from the CONTENT_LENGTH env var yourself (if it's > 0
 * the lib won't set it) and check it before calling DecodeStdin, otherwise
 * you WILL end up with a full filesystem.
*/

int main(int argc, char *argv[])
{
	dentry data[256];
	int num, i;
			
	printf("Content-type: text/html\n\n");
	fflush(stdout);
	
	printf("<html><body bgcolor=\"#ffffff\">\n");
	fflush(stdout);
	sprintf(cgiUploadDir, "/tmp/");

	printf("cgiUploadDir is %s<br>\n", cgiUploadDir);
	if (strcmp(getenv("REQUEST_METHOD"), "POST")!=0)
	{
		printf("Sorry, you must use the POST request method with this form.<p>\n");
		exit(0);
	}

	sscanf(getenv("CONTENT_LENGTH"), "%ld", &contentLength);
	if (contentLength >  1000000L) /* 1M gif/jpg should be enough */
	{
		/* This limitation is just to stop the disk getting full */
		printf ("<b><i>File size too large for upload by this CGI."
			"</b></i><br>\n");
		exit(0);
	}

	printf("decoding stdin<br>\n");
	fflush(stdout);
	
	if((num = DecodeStdin(data)) < 0)
	{
		printf("An Error occured, %s<br>\n", check_dserror(num));
		exit(0);
	}
	
	printf("finished decoding stdin, num = %d printing data values<br>\n", num);
	fflush(stdout);
	
	for(i = 0 ; i < num ; i++)
		printf("i = %d ; data name = %s ; data value = %s ; data type %d<br>\n",
			i, data[i].name, data[i].val, data[i].type); 

	printf("done num = %d<br>\n", num);
	fflush(stdout);
	exit(1);
}
